<?php

function remove_kodik_files() {
	@unlink(ROOT_DIR . '/kodik_install.php');
	@unlink(ROOT_DIR . '/kodik_admin_install.php');
	@unlink(ROOT_DIR . '/kodik_cron.php');
	@unlink(ENGINE_DIR . '/ajax/kodik.php');
	@unlink(ENGINE_DIR . '/classes/kodik.class.php');
	@unlink(ENGINE_DIR . '/data/kodikconfig.php');
	@unlink(ENGINE_DIR . '/inc/kodik.php');
	@unlink(ENGINE_DIR . '/skins/images/kodik.png');
	@listdir(ENGINE_DIR . '/inc/kodik');
	@listdir(ENGINE_DIR . '/skins/kodik');
}

class kodik {
	public $config;
	public $dle_config;
	public $dle_db;
	public $dle_tpl;

	public $copyright = 'Kodik 1.5.2';

	//    
	public $video_type = array(
		'movie' => '',
		'serial' => '',
	);

	//   
	public $fields = array(
		'title' => array(
			'' => ' ',
			'title' => ' ',
		),
		'kinopoisk' => array(
			'' => ' ',
		),
		'output' => array(
			'' => ' ',
			'short_story' => ' ',
			'full_story' => ' ',
		),
	);

	public function __construct($dle_config, $dle_db, $dle_tpl = null) {
		//   
		$this->config = require_once ENGINE_DIR . '/data/kodikconfig.php';

		//   
		$this->dle_config = $dle_config;

		//   
		$this->dle_db = $dle_db;

		//  
		$this->dle_tpl = $dle_tpl;

		//  . 
		$xfields = xfieldsload();
		if ($xfields) foreach ($xfields as $key => $value) {
			$this->fields['title']["{$value[0]}|xfield|{$value[3]}"] = ". : {$value[1]}";
			$this->fields['kinopoisk']["{$value[0]}|xfield|{$value[3]}"] = ". : {$value[1]}";
			$this->fields['output']["{$value[0]}|xfield|{$value[3]}"] = ". : {$value[1]}";
		}
	}

	public function doMain() {
		//      
		include_once ENGINE_DIR . '/inc/kodik/templates/main.php';
	}
	
  public function kodik_get_contents( $file ) {
    $data = false;      
    if( function_exists( 'curl_init' ) ) {
      $ch = curl_init();
      curl_setopt( $ch, CURLOPT_URL, $file );
      curl_setopt( $ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT'] );
      @curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, 1 );
      curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
      curl_setopt( $ch, CURLOPT_TIMEOUT, 5 );
      curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt( $ch, CURLOPT_HEADER, 0);
      $data = curl_exec( $ch );
      curl_close( $ch );
      if( $data !== false ) return $data;
    }

    if( preg_match('/1|yes|on|true/i', ini_get('allow_url_fopen')) ) {
      $data = @file_get_contents( $file );
      if( $data !== false ) return $data;
    }

    return false;
  }
    	
	public function doUpdVoice () {
	
    if($this->config['api_token'] == '') {
      header('Location: ?mod=kodik&action=settings&failed_api=1');
      return false;
    }

		$source = $this->kodik_get_contents('https://kodikapi.com/translations?token=' . $this->config['api_token']);

		if ($source) {
			$voice = json_decode($source, true);

			if ($voice) {
				foreach ($voice as $item) {
					$_voice = $this->dle_db->super_query("SELECT * FROM " . PREFIX . "_kodik_voice WHERE voice_id = '{$item['id']}'");

					if (!$_voice) {

            $item['title'] = convert_unicode($item['title'], $this->dle_config['charset']);

						$voice_id = intval($item['id']);
						$voice_name = $this->dle_db->safesql($item['title']);

						$this->dle_db->query("INSERT INTO " . PREFIX . "_kodik_voice (id, voice_id, voice_name) VALUES (null, '{$voice_id}', '{$voice_name}')");
					}
					
				}
							
			}
			
			
		}
		
		header('Location: ?mod=kodik&action=settings&t_success=1');
			
	}
	
	public function doSettings() {
	
    if (isset($_GET['upd_translations'])) {
      $this->doUpdVoice();
      return false;
    }
	
		//   		
		if (isset($_POST['settings']) AND is_array($_POST['settings'])) {
			//     
			if (isset($_POST['film_voice_save'])) {
				$arr = explode(',', $_POST['film_voice_save']);
				if ($arr)  {
					$this->dle_db->query("UPDATE " . PREFIX . "_kodik_voice SET film_priority = '0'");

					foreach ($arr as $key => $value) {
						$val = explode('|', $value);

						$val[0] = intval($val[0]);
						$val[1] = intval($val[1]);

						$this->dle_db->query("UPDATE " . PREFIX . "_kodik_voice SET film_priority = '{$val[0]}' WHERE id = '{$val[1]}'");
					}
				}
			}

			//     
			if (isset($_POST['serial_voice_save'])) {
				$arr = explode(',', $_POST['serial_voice_save']);
				if ($arr) {
					$this->dle_db->query("UPDATE " . PREFIX . "_kodik_voice SET serial_priority = '0'");

					foreach ($arr as $key => $value) {
						$val = explode('|', $value);

						$val[0] = intval($val[0]);
						$val[1] = intval($val[1]);

						$this->dle_db->query("UPDATE " . PREFIX . "_kodik_voice SET serial_priority = '{$val[0]}' WHERE id = '{$val[1]}'");
					}
				}
			}

			//  
      $save_con = $_POST['settings'];	
      
      foreach ($_POST['replace_arr'] as $key=>$value) {
        if(!empty($value)) $save_con['replace_q'][] = "{$key};{$value}";
        else $save_con['replace_q'][] = "{$key}";
      }
      
      $save_con['replace_q'] = implode("##", $save_con['replace_q']);
      //

      if(stripos($save_con['domain'], "kodik.info") !== false OR stripos($save_con['domain'], "kodik.cc") !== false OR stripos($save_con['domain'], "kodik.biz") !== false) $save_con['domain'] = "";

      $save_con['domain'] = str_replace(["http://", "https://", "//"], "", $save_con['domain']);
      $save_con['domain'] = preg_replace("#/.*#is", "", $save_con['domain']);

      $save_con['replace_q'] = trim(strip_tags(stripslashes( $save_con['replace_q'] )));
      $save_con['replace_q'] = htmlspecialchars( $save_con['replace_q'], ENT_QUOTES, $this->dle_config['charset']);
      
	
			//    					

      $find = array();
      $replace = array();

      $find[] = "'\r'";
      $replace[] = "";
      $find[] = "'\n'";
      $replace[] = "";
				
      //$save_con = $save_con + $this->config;
	  $fh = fopen(ENGINE_DIR . '/data/kodikconfig.php', 'wb+');
			
	  fwrite($fh, "<?php \n\n//Kodik Plugin Configuration\n\nreturn array (\n\n" );
						
	    foreach ($save_con as $name => $value) {
			
        if ($name == 'allowgroups' || $name == 'cron_cats')	$value = implode(',', $value);
        if ($name == 'fields')	$value = implode('|', $value);

        if( $name != "replace_q" ) {
        $value = trim(strip_tags(stripslashes( $value )));
        $value = htmlspecialchars( $value, ENT_QUOTES, $this->dle_config['charset']);
        $value = preg_replace( $find, $replace, $value );

        $name = trim(strip_tags(stripslashes( $name )));
        $name = htmlspecialchars( $name, ENT_QUOTES, $this->dle_config['charset'] );
        $name = preg_replace( $find, $replace, $name );
        }

        $value = str_replace( "$", "&#036;", $value );
        $value = str_replace( "{", "&#123;", $value );
        $value = str_replace( "}", "&#125;", $value );
        $value = str_replace( chr(92), "", $value );
        $value = str_replace( chr(0), "", $value );
        $value = str_replace( '(', "", $value );
        $value = str_replace( ')', "", $value );
        $value = str_ireplace( "base64_decode", "base64_dec&#111;de", $value );

        $name = str_replace( "$", "&#036;", $name );
        $name = str_replace( "{", "&#123;", $name );
        $name = str_replace( "}", "&#125;", $name );
        $name = str_replace( ".", "", $name );
        $name = str_replace( '/', "", $name );
        $name = str_replace( chr(92), "", $name );
        $name = str_replace( chr(0), "", $name );
        $name = str_replace( '(', "", $name );
        $name = str_replace( ')', "", $name );
        $name = str_ireplace( "base64_decode", "base64_dec&#111;de", $name );


				fwrite($fh, "'{$name}' => '{$value}',\n\n" );
			}

			fwrite($fh, ");\n\n?>" );
			
			fclose($fh);

      clear_cache();
      
      if (function_exists('opcache_reset')) {
        opcache_reset();
      }			
      
			header('Location: ?mod=kodik&action=settings');
			return false;
		}
		
		
		
		$kvoice = $this->dle_db->super_query("SELECT COUNT(*) as count FROM " . PREFIX . "_kodik_voice");
		
		if($kvoice['count']) {
		
      $voice_settings = true;
      
      $film_voice_use = array();
      $voice_use_result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_kodik_voice WHERE film_priority > 0 ORDER BY film_priority ASC");
      while ($voice_use_row = $voice_use_result->fetch_assoc()) {
        $film_voice_use[] = $voice_use_row;
      }

      $film_voice_off = array();
      $voice_off_result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_kodik_voice WHERE film_priority = 0 ORDER BY voice_id ASC");
      while ($voice_off_row = $voice_off_result->fetch_assoc()) {
        $film_voice_off[] = $voice_off_row;
      }

      $serial_voice_use = array();
      $voice_use_result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_kodik_voice WHERE serial_priority > 0 ORDER BY serial_priority ASC");
      while ($voice_use_row = $voice_use_result->fetch_assoc()) {
        $serial_voice_use[] = $voice_use_row;
      }

      $serial_voice_off = array();
      $voice_off_result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_kodik_voice WHERE serial_priority = 0 ORDER BY voice_id ASC");
      while ($voice_off_row = $voice_off_result->fetch_assoc()) {
        $serial_voice_off[] = $voice_off_row;
      }		
    
    }
    
    //
    if((!isset($this->config['replace_q']) OR $this->config['replace_q'] == '') AND $this->config['api_token'] != '') {
      $source_qualities = $this->kodik_get_contents('https://kodikapi.com/qualities?token=' . $this->config['api_token']);
			$response_q = @json_decode($source_qualities, true);
			if ($response_q) {
			    
			  $temp_q = array();
        foreach ($response_q as $q_item) {
          $temp_q[] = $q_item['title'];
        }
        
        $this->config['replace_q'] = implode("##", $temp_q);
        
			}
    }
    //

		//     
		include_once ENGINE_DIR . '/inc/kodik/templates/settings.php';

	}

	public function doReplace() {
		//     
		$post = $this->dle_db->super_query("SELECT COUNT(*) as count FROM " . PREFIX . "_post");

		//        /
		include_once ENGINE_DIR . '/inc/kodik/templates/replace.php';
	}
	
	public function doDelete() {
		global $db;

		//    
$kodik_code_button = "

/* Initialization Begin */

//    
require_once ENGINE_DIR . '/inc/kodik/init.php';

//    .   
\$output .= \$kodik->get_button();

/* Initialization End */

";

		//    
$kodik_code_player = "

/* Add Player Begin */

//    
require_once ENGINE_DIR . '/inc/kodik/init.php';

//  
\$kodik->add_player(\$row);

/* Add Player Begin */

";

		$addnews_source = file_get_contents(ENGINE_DIR . '/inc/addnews.php');
		$editnews_source = file_get_contents(ENGINE_DIR . '/inc/editnews.php');
		$showfull_source = file_get_contents(ENGINE_DIR . '/modules/show.full.php');

		$addnews_source = str_replace($kodik_code_button, '', $addnews_source);
		$editnews_source = str_replace($kodik_code_button, '', $editnews_source);
		$showfull_source = str_replace($kodik_code_player, '', $showfull_source);

		file_put_contents(ENGINE_DIR . '/inc/addnews.php', $addnews_source);
		file_put_contents(ENGINE_DIR . '/inc/editnews.php', $editnews_source);
		file_put_contents(ENGINE_DIR . '/modules/show.full.php', $showfull_source);

		$db->query("DROP TABLE IF EXISTS " . PREFIX . "_kodik_voice");

		require_once ENGINE_DIR . '/api/api.class.php';

		$dle_api->uninstall_admin_module('kodik');

		register_shutdown_function('remove_kodik_files');

		die("<p>     !</p>");
	}

	/**
	 *   API kodikapi.com
	 *
	 * @param int $out_base_id id    
	 * @param string $out_field_id    id    
	 * @param string $title   /
	 * @return array   /
	 */
	public function find($out_base_id = 0, $out_field_id = '', $title = '', $with_episodes = false, $strict_title = false) {
		//    
		if (!$this->config['on'])	return array('error' => 'module_is_disabled');

		$strict_title_q = "";
		if ($strict_title) $strict_title_q = "&strict=true";

		//  
		$api_url = "https://kodikapi.com/search?token={$this->config['api_token']}";

    //
    if(($out_field_id == "worldart_cinema_id" OR $out_field_id == "worldart_animation_id") AND stripos($out_base_id, "world-art.ru") !== false) $out_field_id = "worldart_link";

		if ($out_base_id && $out_field_id) $api_url .= "&{$out_field_id}={$out_base_id}";
		else $api_url .= "&title=" . urlencode($title).$strict_title_q;

		if ($with_episodes) $api_url .= "&with_episodes=true";

		if ($this->config['allow_serial'] OR $this->config['allow_film'] OR $this->config['allow_adult']) {
        $add_type = array();
        if($this->config['allow_serial']) $add_type[] = "cartoon-serial,documentary-serial,russian-serial,foreign-serial,anime-serial,multi-part-film,russian-documentary-serial,russian-cartoon-serial";
        if($this->config['allow_film']) $add_type[] = "foreign-movie,soviet-cartoon,foreign-cartoon,russian-cartoon,anime,russian-movie";
        if($this->config['allow_adult']) $add_type[] = "adult";
        $api_url .= "&types=".implode(",", $add_type );
		}
		
		if ($this->config['api_params']) $api_url .= $this->config['api_params'];
		
		$api_url .= "&with_material_data=true"; // always get full info

		//  cURL
		if ($ch = curl_init($api_url)) {
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

      curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 4 );
      curl_setopt($ch, CURLOPT_TIMEOUT, 8 );
      curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
      //curl_setopt($ch, CURLOPT_FAILONERROR, true);

			$output = curl_exec($ch);
      $curl_debug = curl_getinfo($ch);
      
      if(@curl_errno($ch)) {
          die(@json_encode(array('status'=>'error','error'=>"Error! cURL Failed, Request Error: ".@curl_error($ch))));
      }

			curl_close($ch);

			if ($output !== false) {

        if ($this->config['domain']) {
          if (preg_match("/[-]+/i", $this->config['domain'])) $this->config['domain'] = idn_to_ascii($this->config['domain']);
          $output = preg_replace("#\/\/[^\/]+#i", "//".$this->config['domain'], $output);
        }

				$response = @json_decode($output, true);

				if ($response) {								
          //          
          foreach ($response["results"] as $k=>$item) {
              if($this->config['replace_q'] != '') {
                 $temp_qarr = explode("##",$this->config['replace_q']);                 
                 foreach ($temp_qarr as $item_quality) {
                    $item_quality = explode(";", $item_quality);
                    if(count($item_quality) == 2 AND $item_quality[0] == $item["quality"]) $response["results"][$k]["quality"] = $item_quality[1];                    
                 }
              }                            
          }
          //
				
          return $response;
				} else {
          foreach($curl_debug as $field=>$error_data) $infoe .= "\n[{$field}] : {$error_data}";
          die(@json_encode(array('status'=>'error','error'=>'Error! JSON decode failed: request: '. $api_url .' responce: '.$output . ' debug data: '. $infoe)));
				}
			} else {
        $infoe = "";
        foreach($curl_debug as $field=>$error_data) $infoe .= "\n[{$field}] : {$error_data}";
        die(@json_encode(array('status'=>'error','error'=>'Error! cURL result empty, debug data:'.$infoe)));
			}
		} else
			die(@json_encode(array('status'=>'error','error'=>'Error! cURL not present')));
	}

	public function get_replace_threads($type, $threads, $last_post_id = array(), $category = '', $category_inverse = false) {
		if ($type == 2)
			$approve = 'approve = 1';
		elseif ($type == 3)
			$approve = 'approve = 0';

		if ($category) {
			$searchcategory = array();
			$category = explode(',', $category);
			foreach ($category as $category_id) {
				$searchcategory[] = get_sub_cats($category_id);
			}
			$searchcategory = implode('|', $searchcategory);

			if ($searchcategory)
				$searchcategory = "category" . ($category_inverse ? ' not' : '') . " regexp '[[:<:]]($searchcategory)[[:>:]]'";
		}

		if ($last_post_id) {
			$next_posts_id = array();
			$post_result = $this->dle_db->query("SELECT id FROM " . PREFIX . "_post WHERE id < {$last_post_id}" . ($searchcategory ? ' AND ' . $searchcategory : '') . ($approve ? ' AND ' . $approve : '') . " ORDER BY id DESC LIMIT {$threads}");
			while ($post_row = $post_result->fetch_assoc()) {
				$next_posts_id[] = $post_row['id'];
			}

			if ($next_posts_id) {
				$result = array(
					'status' => 'ok',
					'next_posts_id' => $next_posts_id,
				);
			} else
				$result = array(
					'status' => 'end',
				);
		} else {
			$post = $this->dle_db->super_query("SELECT COUNT(*) as count FROM " . PREFIX . "_post WHERE id <> 0 " . ($searchcategory ? ' AND ' . $searchcategory : '') . ($approve ? ' AND ' . $approve : ''));
			if ($post['count']) {
				$next_posts_id = array();
				$post_result = $this->dle_db->query("SELECT id FROM " . PREFIX . "_post WHERE id <> 0 " . ($searchcategory ? ' AND ' . $searchcategory : '') . ($approve ? ' AND ' . $approve : '') . " ORDER BY id DESC LIMIT {$threads}");
				while ($post_row = $post_result->fetch_assoc()) {
					$next_posts_id[] = $post_row['id'];
				}

				if ($next_posts_id) {
					$result = array(
						'status' => 'ok',
						'next_posts_id' => $next_posts_id,
						'count' => $post['count'],
					);
				} else
					$result = array(
						'status' => 'end',
					);
			} else
				$result = array(
					'status' => 'end',
					'code' => '#00',
				);
		}

		return $result;
	}
	
	public function replace_thread($post_id, $fields, $rewrite = false) {
	
    $out_base_name = false;
		$out_base_id = false;	
		$allow_title_search = false;
			
		$post = $this->dle_db->super_query("SELECT * FROM " . PREFIX . "_post WHERE id = {$post_id}");

		//   . 
		$xfieldsdata = xfieldsdataload($post['xfields']);

		//  
		$_field_output = explode('|', $this->config['output']);
		if (count($_field_output) == 3) {
			$output = $xfieldsdata[$_field_output[0]];
		} elseif (count($_field_output) == 1) {
			$output = $post[$_field_output[0]];
		}
		
		if($this->config['output_quality'] != '') {
		$_field_quality = explode('|', $this->config['output_quality']);				
		$output_quality = $xfieldsdata[$_field_quality[0]];
		}
		//
		if($this->config['output_season'] != '') {
		$_field_season = explode('|', $this->config['output_season']);				
		$output_season = intval($xfieldsdata[$_field_season[0]]);	
		}	
		
		if($this->config['output_episode'] != '') {
		$_field_episode = explode('|', $this->config['output_episode']);				
		$output_episode = intval($xfieldsdata[$_field_episode[0]]);			
		}

		//  ID  
		if(in_array("title_strict", $fields)) $allow_title_search = true;
		foreach ($fields as $field_name) {
      
      if ($field_name == "title_strict") continue;
		
			$_field = explode('|', $this->config[$field_name]);
			$_value = $xfieldsdata[$_field[0]];

			if ($_value AND $_value != '') {
				$out_base_id = $_value;
				$out_base_name = $field_name;
			}
		}
		
		//        
    if ($this->config['title'] && !$out_base_id && $allow_title_search) {
      $fields_t = explode('|', $this->config['title']);
      if (count($fields_t) == 3) {
        $out_base_id = $xfieldsdata[$fields_t[0]];
        $out_base_name = "title";
      } elseif (count($fields_t) == 1) {
        $out_base_id = $post[$fields_t[0]];
        $out_base_name = "title";
      }
    }		

		if ($out_base_id && $out_base_name) {

          if ($out_base_name == "world_art_id") $out_base_name = "worldart_cinema_id";
          if ($out_base_name == "world_artanimation_id") $out_base_name = "worldart_animation_id";



          if ($out_base_name == "title") {
            if($this->dle_config['charset'] == "windows-1251") $out_base_id = mb_convert_encoding($out_base_id, "utf-8", "windows-1251");        
            $response_query = $this->find(null,null, $out_base_id, false, true);
          } else $response_query = $this->find($out_base_id, $out_base_name);

					$response = $response_query['results'];

					if ($response[0] AND $response[0]['link'] AND $response_query['total'] != 0) {
					
            $iframe_voiceall = array();
						foreach ($response as $key => $item) {
              if( $this->config['noupdate_ua'] AND $item['translation']['title'] == "") unset($response[$key]);
							$response[$key]['translator_id'] = intval($item['translation']['id']);
							
							$iframe_voiceall[] = $item['translation']['title'];
						}
						                    
            $iframe_year = $response[0]['year'];  // static
            $iframe_title = $response[0]['title'];  // static
            $iframe_origtitle = $response[0]['title_orig'];  // static
            $iframe_kinopoisk_id = $response[0]['kinopoisk_id'];  // static
            $iframe_imdb_id = $response[0]['imdb_id']; // static  

            $iframe_pornolab_id = $response[0]['pornolab_id']; // static
            $iframe_worldartlink = $response[0]['worldart_link'];  // static
            
            $iframe_url = $response[0]['link'];
            
            $iframe_voice = $response[0]['translation']['title'];
            $iframe_quality = $response[0]['quality'];
            
            $iframe_lastseason = isset($response[0]['last_season']) ? $response[0]['last_season'] : 0;
            $iframe_lastepisode = isset($response[0]['last_episode']) ? $response[0]['last_episode'] : 0;	       
            //
            //
            //
            $iframe_kp_description = $response[0]['material_data']['description'];  // static
            $iframe_kp_poster_url = $response[0]['material_data']['poster_url'];  // static                
            $iframe_kp_duration = $response[0]['material_data']['duration'];  // static                
            $iframe_kp_countries = $response[0]['material_data']['countries'];  // static array
            $iframe_kp_genres = $response[0]['material_data']['genres'];  // static array
                                    
            $iframe_kp_actors = $response[0]['material_data']['actors'];  // static array
            $iframe_kp_directors = $response[0]['material_data']['directors'];  // static array
            $iframe_kp_producers = $response[0]['material_data']['producers'];  // static array
            $iframe_kp_writers = $response[0]['material_data']['writers'];  // static array
            

            $iframe_kp_tagline = $response[0]['material_data']['tagline'];  // static
            $iframe_kp_kinopoisk_rating = $response[0]['material_data']['kinopoisk_rating'];  // static
            $iframe_kp_kinopoisk_votes = $response[0]['material_data']['kinopoisk_votes'];  // static
            $iframe_kp_imdb_rating = $response[0]['material_data']['imdb_rating'];  // static
            $iframe_kp_imdb_votes = $response[0]['material_data']['imdb_votes'];  // static
            $iframe_kp_premiere_ru = $response[0]['material_data']['premiere_ru'];  // static
            $iframe_kp_premiere_world = $response[0]['material_data']['premiere_world'];  // static
                                  
            
            $iframe_kp_composers = $response[0]['material_data']['composers'];  // static array
            $iframe_kp_editors = $response[0]['material_data']['editors'];  // static array
            $iframe_kp_designers = $response[0]['material_data']['designers'];  // static array    
            $iframe_kp_operators = $response[0]['material_data']['operators'];  // static array
            //              
            //
            //            

            $film_array = array('foreign-movie', 'soviet-cartoon', 'foreign-cartoon', 'russian-cartoon', 'anime', 'russian-movie');

            if (in_array($response[0]['type'], $film_array))
              $voice_type = 'film';
            else
              $voice_type = 'serial';
              
            //
            $more_recent = true;
            
            if ($voice_type == 'serial' AND $this->config['onlynewserials']) {
              $max_season = array(0, 0, 0);
              $more_recent = false;
              
              foreach ($response as $id=>$item) {                            
                 if($item['last_season'] > $max_season[1]) {
                   $max_season = array($id, $item['last_season'], $item['last_episode']);
                 }
                 
                 if($item['last_episode'] > $max_season[2] AND $item['last_season'] >= $max_season[1]) {
                   $max_season = array($id, $item['last_season'], $item['last_episode']);
                 }
              }
              
              $iframe_url = $response[$max_season[0]]['link'];

              if ($max_season[1] > $output_season OR ($max_season[1] >= $output_season AND $max_season[2] > $output_episode)) {
              
                  $more_recent = true;
                  
                  $iframe_url = $response[$max_season[0]]['link'];
                    
                  $iframe_voice = $response[$max_season[0]]['translation']['title'];
                  $iframe_quality = $response[$max_season[0]]['quality'];
                    
                  $iframe_lastseason = $response[$max_season[0]]['last_season'];
                  $iframe_lastepisode = $response[$max_season[0]]['last_episode'];            
                  
                  foreach ($response as $key=>$item) {
                     if( $item['last_season'] < $max_season[1] OR ($max_season[1] == $item['last_season'] AND $item['last_episode'] < $max_season[2])) {
                        unset($response[$key]); 
                     }
                  }
             }
            }
            //              

						switch ($this->config["{$voice_type}_quality"]) {
							case 1:
								foreach ($response as $item) {
									if (!$item['camrip']) {
										$iframe_url = $item['link'];
                    $iframe_quality = $item['quality'];
                    $iframe_voice = $item['translation']['title'];
                    $iframe_lastseason = isset($item['last_season']) ? $item['last_season'] : 0;
                    $iframe_lastepisode = isset($item['last_episode']) ? $item['last_episode'] : 0;                    										
										break;
									}
								}
								break;

							case 2:
								$result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_kodik_voice WHERE {$voice_type}_priority > 0 ORDER BY {$voice_type}_priority ASC");
								while ($row = $result->fetch_assoc()) {
									foreach ($response as $item) {
										if ($item['translator_id'] == $row['voice_id']) {
											$iframe_url = $item['link'];
                      $iframe_quality = $item['quality'];
                      $iframe_voice = $item['translation']['title'];	
                      $iframe_lastseason = isset($item['last_season']) ? $item['last_season'] : 0;
                      $iframe_lastepisode = isset($item['last_episode']) ? $item['last_episode'] : 0;                      										
											break 2;
										}
									}
								}
								break;

							case 3:
								$result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_kodik_voice WHERE {$voice_type}_priority > 0 ORDER BY {$voice_type}_priority ASC");
								while ($row = $result->fetch_assoc()) {
									foreach ($response as $item) {
										if ($item['translator_id'] == $row['voice_id']) {
											$iframe_url = $item['link'];
                      $iframe_quality = $item['quality'];
                      $iframe_voice = $item['translation']['title'];	
                      $iframe_lastseason = isset($item['last_season']) ? $item['last_season'] : 0;
                      $iframe_lastepisode = isset($item['last_episode']) ? $item['last_episode'] : 0;                      										

											if ($item['camrip']) {
												foreach ($response as $_item) {
													if ($_item['translator_id'] == $row['voice_id'] && !$_item['camrip']) {
														$iframe_url = $_item['link'];
                            $iframe_quality = $_item['quality'];
                            $iframe_voice = $_item['translation']['title'];
                            $iframe_lastseason = isset($_item['last_season']) ? $_item['last_season'] : 0;
                            $iframe_lastepisode = isset($_item['last_episode']) ? $_item['last_episode'] : 0;	                            														
														break;
													}
												}
											}

											break 2;
										}
									}
								}
								break;

							case 4:
								foreach ($response as $item) {
									if (!$item['camrip']) {
										$iframe_url = $item['link'];
                    $iframe_quality = $item['quality'];
                    $iframe_voice = $item['translation']['title'];
                    $iframe_lastseason = isset($item['last_season']) ? $item['last_season'] : 0;
                    $iframe_lastepisode = isset($item['last_episode']) ? $item['last_episode'] : 0;

										$result = $this->dle_db->query("SELECT * FROM " . PREFIX . "_kodik_voice WHERE {$voice_type}_priority > 0 ORDER BY {$voice_type}_priority ASC");
										while ($row = $result->fetch_assoc()) {
											foreach ($response as $_item) {
												if (!$_item['camrip'] && $_item['translator_id'] == $row['voice_id']) {
													$iframe_url = $_item['link'];
                          $iframe_quality = $_item['quality'];
                          $iframe_voice = $_item['translation']['title'];		
                          $iframe_lastseason = isset($_item['last_season']) ? $_item['last_season'] : 0;
                          $iframe_lastepisode = isset($_item['last_episode']) ? $_item['last_episode'] : 0;	                          											
													break 2;
												}
											}
										}

										break;
									}
								}
								break;
						}

            //
            //
            //
            if ( (($iframe_url != '' AND $iframe_url != $output) OR ($iframe_quality != '' AND $iframe_quality != $output_quality) AND $more_recent) OR $rewrite) {
                      
                $field_set = array();                
                // this field is used
					                      
                  if ($this->config['output']) {
                    if ($this->config['player_params']) $iframe_url .= $this->config['player_params'];
                    
                    $_field = explode('|', $this->config['output']);
                    if(count($_field) == 1) $field_set[] = "{$_field[0]}='".$this->dle_db->safesql($iframe_url)."'";
                    elseif(count($_field) == 3) $xfieldsdata[$_field_output[0]] = $iframe_url;
                  }
                                
                  // add new fields data
                  
                  if ($this->config['output_voice']) {
                    $_field = explode('|', $this->config['output_voice']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_voice, $this->dle_config['charset']);
                  }
                  
                  if ($this->config['output_quality']) {
                    $_field = explode('|', $this->config['output_quality']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_quality, $this->dle_config['charset']);
                  }
                  
                  if ($this->config['kinopoisk_id'] AND $this->config['allow_autopaste'] AND $iframe_kinopoisk_id != '') {
                    $_field = explode('|', $this->config['kinopoisk_id']);
                    $xfieldsdata[$_field[0]] = $iframe_kinopoisk_id;
                  }
                  
                  if ($this->config['imdb_id'] AND $this->config['allow_autopaste'] AND $iframe_imdb_id != '') {
                    $_field = explode('|', $this->config['imdb_id']);
                    $xfieldsdata[$_field[0]] = $iframe_imdb_id;
                  }		
                  
                  if ($this->config['pornolab_id'] AND $this->config['allow_autopaste'] AND $iframe_pornolab_id != '') {
                    $_field = explode('|', $this->config['pornolab_id']);
                    $xfieldsdata[$_field[0]] = $iframe_pornolab_id;
                  }	  
                  
                
                  if ($this->config['world_art_id'] AND $this->config['allow_autopaste'] AND $iframe_worldartlink != '') {
                    $_field = explode('|', $this->config['world_art_id']);
                    if (preg_match('#cinema\.php\?id=(\d+)#', $iframe_worldartlink, $matches)) {
                      $xfieldsdata[$_field[0]] = $matches[1];
                    }
                  }
                  
                  if ($this->config['world_artanimation_id'] AND $this->config['allow_autopaste'] AND $iframe_worldartlink != '') {
                    $_field = explode('|', $this->config['world_artanimation_id']);
                    if (preg_match('#animation\.php\?id=(\d+)#', $iframe_worldartlink, $matches)) {
                      $xfieldsdata[$_field[0]] = $matches[1];
                    }
                  }
                  
                  if ($this->config['output_title'] AND $iframe_title != '') {
                    $_field = explode('|', $this->config['output_title']);              
                    if(count($_field) == 1) $field_set[] = "{$_field[0]}='".$this->dle_db->safesql(convert_unicode($iframe_title, $this->dle_config['charset']))."'";
                    elseif(count($_field) == 3) $xfieldsdata[$_field[0]] = convert_unicode($iframe_title, $this->dle_config['charset']);
                  }
                  
                  if ($this->config['output_otitle'] AND $iframe_origtitle != '') {
                    $_field = explode('|', $this->config['output_otitle']);
                    if(count($_field) == 1) $field_set[] = "{$_field[0]}='".$this->dle_db->safesql(convert_unicode($iframe_origtitle, $this->dle_config['charset']))."'";
                    elseif(count($_field) == 3) $xfieldsdata[$_field[0]] = convert_unicode($iframe_origtitle, $this->dle_config['charset']);  
                  }			
                  
                  if ($this->config['world_art_link'] AND $iframe_worldartlink != '') {
                    $_field = explode('|', $this->config['world_art_link']);
                    $xfieldsdata[$_field[0]] = $iframe_worldartlink;
                  }
                                    
                  if ($this->config['output_year'] AND $iframe_year != '') {
                    $_field = explode('|', $this->config['output_year']);
                    $xfieldsdata[$_field[0]] = $iframe_year;
                  }										
                  
                  if ($this->config['output_season'] && $iframe_lastseason > 0) {
                    $_field = explode('|', $this->config['output_season']);
                    $xfieldsdata[$_field[0]] = $iframe_lastseason;
                  }
                  
                  if ($this->config['output_episode'] && $iframe_lastepisode > 0) {
                    $_field = explode('|', $this->config['output_episode']);
                    $xfieldsdata[$_field[0]] = $iframe_lastepisode;												
                  }              
                              
                  //
                  //				
                  //
                  
                  if ($this->config['output_voiceall'] AND !empty($iframe_voiceall)) {
                    $iframe_voiceall = array_unique($iframe_voiceall);
                    $iframe_voiceall = implode(", ", $iframe_voiceall);
                    $_field = explode('|', $this->config['output_voiceall']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_voiceall, $this->dle_config['charset']);
                  }
                  
                  //
                  if ($this->config['output_kp_description'] AND $iframe_kp_description != '') {
                    $_field = explode('|', $this->config['output_kp_description']);
                    if(count($_field) == 1) $field_set[] = "{$_field[0]}='".$this->dle_db->safesql(convert_unicode($iframe_kp_description, $this->dle_config['charset']))."'";
                    elseif(count($_field) == 3) $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_description, $this->dle_config['charset']);
                  }			
                  
                  
                  if ($this->config['output_kp_poster_url'] AND $iframe_kp_poster_url != '') {
                    $_field = explode('|', $this->config['output_kp_poster_url']);
                    $xfieldsdata[$_field[0]] = $iframe_kp_poster_url;
                  }				
                  
                  
                  if ($this->config['output_kp_duration'] AND $iframe_kp_duration != '') {
                    $_field = explode('|', $this->config['output_kp_duration']);
                    $xfieldsdata[$_field[0]] = $iframe_kp_duration;
                  }												
                  
                  
                  if ($this->config['output_kp_countries'] AND !empty($iframe_kp_countries)) {
                    $iframe_kp_countries = implode(", ", $iframe_kp_countries);
                    $_field = explode('|', $this->config['output_kp_countries']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_countries, $this->dle_config['charset']);
                  }	
                  
                  
                  if ($this->config['output_kp_genres'] AND !empty($iframe_kp_genres)) {
                    $iframe_kp_genres = implode(", ", $iframe_kp_genres);
                    $_field = explode('|', $this->config['output_kp_genres']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_genres, $this->dle_config['charset']);
                  }		
                  
                  
                  if ($this->config['output_kp_actors'] AND !empty($iframe_kp_actors)) {
                    $iframe_kp_actors = implode(", ", $iframe_kp_actors);
                    $_field = explode('|', $this->config['output_kp_actors']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_actors, $this->dle_config['charset']);
                  }	
                  
                  
                  if ($this->config['output_kp_directors'] AND !empty($iframe_kp_directors)) {
                    $iframe_kp_directors = implode(", ", $iframe_kp_directors);
                    $_field = explode('|', $this->config['output_kp_directors']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_directors, $this->dle_config['charset']);
                  }	
                            
                  
                  if ($this->config['output_kp_producers'] AND !empty($iframe_kp_producers)) {
                    $iframe_kp_producers = implode(", ", $iframe_kp_producers);
                    $_field = explode('|', $this->config['output_kp_producers']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_producers, $this->dle_config['charset']);
                  }	
                  
                  
                  if ($this->config['output_kp_writers'] AND !empty($iframe_kp_writers)) {
                    $iframe_kp_writers = implode(", ", $iframe_kp_writers);
                    $_field = explode('|', $this->config['output_kp_writers']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_writers, $this->dle_config['charset']);
                  }	
                  
                  
                  if ($this->config['output_kp_tagline'] AND $iframe_kp_tagline != '') {
                    $_field = explode('|', $this->config['output_kp_tagline']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_tagline, $this->dle_config['charset']);
                  }	
                  
                  if ($this->config['output_kp_kinopoisk_rating'] AND $iframe_kp_kinopoisk_rating != '') {
                    $_field = explode('|', $this->config['output_kp_kinopoisk_rating']);
                    $xfieldsdata[$_field[0]] = $iframe_kp_kinopoisk_rating;
                  }	
                  
                  
                  if ($this->config['output_kp_kinopoisk_votes'] AND $iframe_kp_kinopoisk_votes != '') {
                    $_field = explode('|', $this->config['output_kp_kinopoisk_votes']);
                    $xfieldsdata[$_field[0]] = $iframe_kp_kinopoisk_votes;
                  }	
                  
                  if ($this->config['output_kp_imdb_rating'] AND $iframe_kp_imdb_rating != '') {
                    $_field = explode('|', $this->config['output_kp_imdb_rating']);
                    $xfieldsdata[$_field[0]] = $iframe_kp_imdb_rating;
                  }	
                  
                  
                  if ($this->config['output_kp_imdb_votes'] AND $iframe_kp_imdb_votes != '') {
                    $_field = explode('|', $this->config['output_kp_imdb_votes']);
                    $xfieldsdata[$_field[0]] = $iframe_kp_imdb_votes;
                  }	
                  
                  if ($this->config['output_kp_premiere_ru'] AND $iframe_kp_premiere_ru != '') {
                    $_field = explode('|', $this->config['output_kp_premiere_ru']);
                    $xfieldsdata[$_field[0]] = $iframe_kp_premiere_ru;
                  }	
                  
                  
                  if ($this->config['output_kp_premiere_world'] AND $iframe_kp_premiere_world != '') {
                    $_field = explode('|', $this->config['output_kp_premiere_world']);
                    $xfieldsdata[$_field[0]] = $iframe_kp_premiere_world;
                  }	
                  
                  
                  if ($this->config['output_kp_composers'] AND !empty($iframe_kp_composers)) {
                    $iframe_kp_composers = implode(", ", $iframe_kp_composers);	
                    $_field = explode('|', $this->config['output_kp_composers']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_composers, $this->dle_config['charset']);
                  }	
                  
                  
                  if ($this->config['output_kp_editors'] AND !empty($iframe_kp_editors)) {
                    $iframe_kp_editors = implode(", ", $iframe_kp_editors);
                    $_field = explode('|', $this->config['output_kp_editors']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_editors, $this->dle_config['charset']);
                  }	
                  
                  
                  if ($this->config['output_kp_designers'] AND !empty($iframe_kp_designers)) {
                    $iframe_kp_designers = implode(", ", $iframe_kp_designers);
                    $_field = explode('|', $this->config['output_kp_designers']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_designers, $this->dle_config['charset']);
                  }																	
                  
                  if ($this->config['output_kp_operators'] AND !empty($iframe_kp_operators)) {
                    $iframe_kp_operators = implode(", ", $iframe_kp_operators);
                    $_field = explode('|', $this->config['output_kp_operators']);
                    $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_operators, $this->dle_config['charset']);
                  }		
                  //
                  //																																																															
                  //

                  $xfields = array();
                  foreach ($xfieldsdata as $key => $value) {
                    $value = str_replace('|', '&#124;', $value);
                    $xfields[] = "$key|$value";
                  }
                  $xfields = implode('||', $xfields);

                  $xfields = addslashes($xfields);
                  
                  $up_date = "";
                  if ($this->config['up_news']) {
                    $thistime = date( "Y-m-d H:i:s", time() );
                    $up_date = ", date='{$thistime}' ";
                  }
                  
                  if(count($field_set)) {
                    $set_nativefields = ", ". implode(", ", $field_set);
                  }

                  $this->dle_db->query("UPDATE " . PREFIX . "_post SET xfields = '{$xfields}'{$up_date}{$set_nativefields} WHERE id='{$post_id}'");

                $result = array(
                  'status' => 'ok',
                );
						
						} else $result = array(
						'status' => 'exist',
            );
						
					} else
						$result = array(
							'status' => 'error',
							'code' => '#02',
						);
		} else
			$result = array(
				'status' => 'error',
				'code' => '#01',
			);

		$result['post'] = $post;
		$result['kinopoisk_id'] = $kinopoisk_id;
		$result['out_base_id'] = $out_base_id;
		$result['out_base_name'] = $out_base_name;

		if ($result['status'] == 'ok') {
			if ($this->dle_config['allow_alt_url']) {
				if ($this->dle_config['seo_type'] == 1 || $this->dle_config['seo_type'] == 2) {
					$result['post']['category'] = intval($result['post']['category']);
					if ($result['post']['category'] && $this->dle_config['seo_type'] == 2) {
						$full_link = $this->dle_config['http_home_url'] . get_url($result['post']['category']) . "/" . $result['post']['id'] . "-" . $result['post']['alt_name'] . ".html";
					} else {
						$full_link = $this->dle_config['http_home_url'] . $result['post']['id'] . "-" . $result['post']['alt_name'] . ".html";
					}
				} else {
					$full_link = $this->dle_config['http_home_url'] . date('Y/m/d/', $result['post']['date']) . $result['post']['alt_name'] . ".html";
				}
			} else {
				$full_link = $this->dle_config['http_home_url'] . "index.php?newsid=" . $result['post']['id'];
			}

			$log_string = " $full_link" . ($result['out_base_id'] ? " ({$result['out_base_name']}: {$result['out_base_id']})" : '') . "\r\n";
			file_put_contents(ENGINE_DIR . '/inc/kodik/reports/success.log', $log_string, FILE_APPEND | LOCK_EX);
		}

		if ($result['status'] == 'exist') {
			if ($this->dle_config['allow_alt_url']) {
				if ($this->dle_config['seo_type'] == 1 || $this->dle_config['seo_type'] == 2) {
					$result['post']['category'] = intval($result['post']['category']);
					if ($result['post']['category'] && $this->dle_config['seo_type'] == 2) {
						$full_link = $this->dle_config['http_home_url'] . get_url($result['post']['category']) . "/" . $result['post']['id'] . "-" . $result['post']['alt_name'] . ".html";
					} else {
						$full_link = $this->dle_config['http_home_url'] . $result['post']['id'] . "-" . $result['post']['alt_name'] . ".html";
					}
				} else {
					$full_link = $this->dle_config['http_home_url'] . date('Y/m/d/', $result['post']['date']) . $result['post']['alt_name'] . ".html";
				}
			} else {
				$full_link = $this->dle_config['http_home_url'] . "index.php?newsid=" . $result['post']['id'];
			}

			$log_string = " $full_link" . ($result['out_base_id'] ? " ({$result['out_base_name']}: {$result['out_base_id']})" : '') . "\r\n";
			file_put_contents(ENGINE_DIR . '/inc/kodik/reports/found.log', $log_string, FILE_APPEND | LOCK_EX);
		}

		return $result;
	}

	/**
	 *   
	 *
	 * @return string         
	 */
	public function get_button() {
		global $member_id;

		//    
		if (!$this->config['on'])
			return '';

		if (!in_array($member_id['user_group'], explode(',', $this->config['allowgroups'])))
			return '';

		//    
		ob_start();
		include_once ENGINE_DIR . '/inc/kodik/templates/button.php';
		$button_template = ob_get_clean();

		//          DLE
		if ($this->dle_config['version_id'] < 10.2) {
			//    10.2
			$button_template = "<tr>
				<td width=\"140\" height=\"29\" style=\"padding-left:5px;\">Kodik:</td>
				<td>
					{$button_template}
				</td>
			</tr>";
		} else {
			//   10.2  
			$button_template = "<div class=\"form-group\">
				<label class=\"control-label col-lg-2\">Kodik:</label>
				<div class=\"col-lg-10\">
					{$button_template}
				</div>
			</div>";
		}

		return $button_template;
	}

	/**
	 *      
	 *
	 * @param object $tpl 
	 * @param array $row  
	 */
	public function add_player($row) {
		//    
		if (!$this->config['on'])
			return false;

		if ($this->config['on'] and $row and strpos($this->dle_tpl->copy_template, '{kodik-player}') !== false) {
			//   . 
			$xfieldsdata = xfieldsdataload($row['xfields']);

			//  
			$_field = explode('|', $this->config['output']);
			if (count($_field) == 3) {
				$kodik_video_url = $xfieldsdata[$_field[0]];
			} elseif (count($_field) == 1) {
				$kodik_video_url = $row[$_field[0]];
			}

			//           
			if ($kodik_video_url && $this->config['video_width'] && $this->config['video_height']) {
				//    
				$kodik_player = "<iframe src=\"{$kodik_video_url}\" width=\"{$this->config['video_width']}\" height=\"{$this->config['video_height']}\" frameborder=\"0\" allowfullscreen></iframe>";

				//  {kodik-player}   
				$this->dle_tpl->copy_template = str_replace('{kodik-player}', $kodik_player, $this->dle_tpl->copy_template);

				//      [kodik-player]...[/kodik-player]       
				$this->dle_tpl->copy_template = str_replace('[kodik-player]', '', $this->dle_tpl->copy_template);
				$this->dle_tpl->copy_template = str_replace('[/kodik-player]', '', $this->dle_tpl->copy_template);
			//      
			} else {
				//     
				$this->dle_tpl->copy_template = str_replace('{kodik-player}', '', $this->dle_tpl->copy_template);

				//      ,         [kodik-player]...[/kodik-player]
				$this->dle_tpl->copy_template = preg_replace("'\\[kodik-player\\](.*?)\\[/kodik-player\\]'is", '', $this->dle_tpl->copy_template);
			}
		}
	}
}