<?php

@set_time_limit(0);

if (!defined('E_DEPRECATED')) {
	@error_reporting(E_ALL ^ E_NOTICE);
	@ini_set('error_reporting', E_ALL ^ E_NOTICE);
} else {
	@error_reporting(E_ALL ^ E_DEPRECATED ^ E_NOTICE);
	@ini_set('error_reporting', E_ALL ^ E_DEPRECATED ^ E_NOTICE);
}

@ini_set('display_errors', true);
@ini_set('html_errors', false);

define('DATALIFEENGINE', true);
define('AUTOMODE', true);
define('LOGGED_IN', true);

define('ROOT_DIR', dirname (__FILE__));
define('ENGINE_DIR', ROOT_DIR . '/engine');

@include_once ENGINE_DIR . '/classes/plugins.class.php';
require_once ENGINE_DIR . '/data/config.php';

date_default_timezone_set($config['date_adjust']);

require_once ENGINE_DIR . '/classes/mysql.php';
require_once ENGINE_DIR . '/data/dbconfig.php';
require_once ENGINE_DIR . '/modules/functions.php';

dle_session();

//####################################################################################################################
//                        
//####################################################################################################################
$cat_info = get_vars("category");

if (!is_array($cat_info)) {
	$cat_info = array();
	
	$db->query("SELECT * FROM " . PREFIX . "_category ORDER BY posi ASC");
	while ($row = $db->get_row()) {
		$cat_info[$row['id']] = array();
		
		foreach ($row as $key => $value) {
			$cat_info[$row['id']][$key] = stripslashes($value);
		}
	}

	set_vars("category", $cat_info);
	$db->free();
}

//    
require_once ENGINE_DIR . '/inc/kodik/init.php';

if ($kodik->config['cron_key'] && $kodik->config['cron_key'] == $_GET['key']) {
	$cats = explode(',', $kodik->config['cron_cats']);
	$black_list = explode(',', $kodik->config['cron_black_list']);

	if ($kodik->config['cron_type'] == 2)
		$approve = 'approve = 1';
	elseif ($kodik->config['cron_type'] == 3)
		$approve = 'approve = 0';

	if ($kodik->config['cron_white_list']) {
		$searchids = "id IN (" . $kodik->config['cron_white_list'] . ")";
	}

	if ($cats) {
		$searchcategory = array();
		foreach ($cats as $cat_id) {
			$searchcategory[] = get_sub_cats($cat_id);
		}
		$searchcategory = implode('|', $searchcategory);

		if ($searchcategory)
			$searchcategory = "category" . ($kodik->config['cron_cats_inverse'] ? ' not' : '') . " regexp '[[:<:]]($searchcategory)[[:>:]]'";
	}

	$threads = 0;
	
	if($kodik->config['cron_mode'] == 0) {
    $result_post = $kodik->dle_db->query("SELECT * FROM " . PREFIX . "_post WHERE id > 0 " . ($searchcategory ? ' AND ' . $searchcategory : '') . ($approve ? ' AND ' . $approve : '') . ($searchids ? ' OR ' . $searchids : '') . " ORDER BY id DESC");
	}
	
	if($kodik->config['cron_mode'] == 1) {
    ignore_user_abort(true);
    $total_post = $kodik->dle_db->super_query("SELECT COUNT(id) as count FROM " . PREFIX . "_post WHERE id > 0 " . ($searchcategory ? ' AND ' . $searchcategory : '') . ($approve ? ' AND ' . $approve : '') . ($searchids ? ' OR ' . $searchids : '') . "");
      
    $start_from = 0;
    $max_step = $kodik->config['cron_threads'] * 10;	
    $total = $total_post['count'] + $max_step;
    
    row_init:
    
    //if ($start_from >= $total) die('cron is finised, news checked: '.$total);
    if ($start_from >= $total) die();
    
    $result_post = $kodik->dle_db->query("SELECT * FROM " . PREFIX . "_post WHERE id > 0 " . ($searchcategory ? ' AND ' . $searchcategory : '') . ($approve ? ' AND ' . $approve : '') . ($searchids ? ' OR ' . $searchids : '') . " ORDER BY id DESC LIMIT {$start_from}, {$max_step}");	    
	}
	
	while ($post = $result_post->fetch_assoc()) {
	
    $out_base_name = false;
		$out_base_id = false;		
		$allow_title_search = false;
					
		$threads++;
				

		if (in_array($post['id'], $black_list))
			continue;

		// ----- BEGIN UPDATE POST -----

		//   . 
		$xfieldsdata = xfieldsdataload($post['xfields']);
		
		//  
		$_field_output = explode('|', $kodik->config['output']);
		if (count($_field_output) == 3) {
			$output = $xfieldsdata[$_field_output[0]];
		} elseif (count($_field_output) == 1) {
			$output = $post[$_field_output[0]];
		}
		
		if($kodik->config['output_quality'] != '') {
		$_field_quality = explode('|', $kodik->config['output_quality']);
		$output_quality = $xfieldsdata[$_field_quality[0]];
		}
		//
		if($kodik->config['output_season'] != '') {
		$_field_season = explode('|', $kodik->config['output_season']);
		$output_season = intval($xfieldsdata[$_field_season[0]]);
		}
		
		if($kodik->config['output_episode'] != '') {
		$_field_episode = explode('|', $kodik->config['output_episode']);
		$output_episode = intval($xfieldsdata[$_field_episode[0]]);
		}

		//  ID  
		if ($kodik->config['fields']) {
			$fields = explode('|', $kodik->config['fields']);				
			if(in_array("title_strict", $fields)) $allow_title_search = true;
			foreach ($fields as $field_name) {
        if ($field_name == "title_strict") continue;        
				$_field = explode('|', $kodik->config[$field_name]);
				$_value = $xfieldsdata[$_field[0]];

				if ($_value AND $_value != '') {
					$out_base_id = $_value;
					$out_base_name = $field_name;
				}
			}
		}
				
		//        
    if ($kodik->config['title'] && !$out_base_id && $allow_title_search) {
      $fields_t = explode('|', $kodik->config['title']);
      if (count($fields_t) == 3) {
        $out_base_id = $xfieldsdata[$fields_t[0]];
        $out_base_name = "title";
      } elseif (count($fields_t) == 1) {
        $out_base_id = $post[$fields_t[0]];
        $out_base_name = "title";
      }
    }
						
		if ($out_base_id && $out_base_name) {
		
      if ($out_base_name == "world_art_id") $out_base_name = "worldart_cinema_id";
      if ($out_base_name == "world_artanimation_id") $out_base_name = "worldart_animation_id";      
		
      if ($out_base_name == "title") {
        if($config['charset'] == "windows-1251") $out_base_id = mb_convert_encoding($out_base_id, "utf-8", "windows-1251");        
        $response_query = $kodik->find(null,null, $out_base_id, false, true);
			} else $response_query = $kodik->find($out_base_id, $out_base_name);
			
			if($response_query['total'] == 0) continue; // no results DELETED?						
			$response = $response_query['results'];
						
			if ($response[0] AND $response[0]['link']) {
			
        $iframe_voiceall = array();
        
				foreach ($response as $key => $item) {
          if( $kodik->config['noupdate_ua'] AND $item['translation']['title'] == "") unset($response[$key]);
					$response[$key]['translator_id'] = intval($item['translation']['id']);
					//
					$iframe_voiceall[] = $item['translation']['title'];
				}
				
				if(count($response) == 0) continue;
								
        $iframe_year = $response[0]['year'];  // static
        $iframe_title = $response[0]['title'];  // static
        $iframe_origtitle = $response[0]['title_orig'];  // static                
        $iframe_kinopoisk_id = $response[0]['kinopoisk_id'];  // static
        $iframe_imdb_id = $response[0]['imdb_id']; // static  
        $iframe_pornolab_id = $response[0]['pornolab_id']; // static          
        $iframe_worldartlink = $response[0]['worldart_link'];  // static
        
        $iframe_url = $response[0]['link'];
        
        $iframe_voice = $response[0]['translation']['title'];
        $iframe_quality = $response[0]['quality'];
        
        $iframe_lastseason = isset($response[0]['last_season']) ? $response[0]['last_season'] : 0;
        $iframe_lastepisode = isset($response[0]['last_episode']) ? $response[0]['last_episode'] : 0;	       
        
        //
        //
        //
        $iframe_kp_description = $response[0]['material_data']['description'];  // static
        $iframe_kp_poster_url = $response[0]['material_data']['poster_url'];  // static                
        $iframe_kp_duration = $response[0]['material_data']['duration'];  // static                
        $iframe_kp_countries = $response[0]['material_data']['countries'];  // static array
        $iframe_kp_genres = $response[0]['material_data']['genres'];  // static array
                                
        $iframe_kp_actors = $response[0]['material_data']['actors'];  // static array
        $iframe_kp_directors = $response[0]['material_data']['directors'];  // static array
        $iframe_kp_producers = $response[0]['material_data']['producers'];  // static array
        $iframe_kp_writers = $response[0]['material_data']['writers'];  // static array
        

        $iframe_kp_tagline = $response[0]['material_data']['tagline'];  // static
        $iframe_kp_kinopoisk_rating = $response[0]['material_data']['kinopoisk_rating'];  // static
        $iframe_kp_kinopoisk_votes = $response[0]['material_data']['kinopoisk_votes'];  // static
        $iframe_kp_imdb_rating = $response[0]['material_data']['imdb_rating'];  // static
        $iframe_kp_imdb_votes = $response[0]['material_data']['imdb_votes'];  // static
        $iframe_kp_premiere_ru = $response[0]['material_data']['premiere_ru'];  // static
        $iframe_kp_premiere_world = $response[0]['material_data']['premiere_world'];  // static
                              
        
        $iframe_kp_composers = $response[0]['material_data']['composers'];  // static array
        $iframe_kp_editors = $response[0]['material_data']['editors'];  // static array
        $iframe_kp_designers = $response[0]['material_data']['designers'];  // static array    
        $iframe_kp_operators = $response[0]['material_data']['operators'];  // static array
        //              
        //
        //

        $film_array = array('foreign-movie', 'soviet-cartoon', 'foreign-cartoon', 'russian-cartoon', 'anime', 'russian-movie');

				if (in_array($response[0]['type'], $film_array))
					$voice_type = 'film';
				else
					$voice_type = 'serial';
										
				//
				$more_recent = true;
				
        if ($voice_type == 'serial' AND $kodik->config['onlynewserials']) {
          $max_season = array(0, 0, 0);
          $more_recent = false;
          
          foreach ($response as $id=>$item) {
             if($item['last_season'] > $max_season[1]) {
               $max_season = array($id, $item['last_season'], $item['last_episode']);
             }
             if($item['last_episode'] > $max_season[2] AND $item['last_season'] >= $max_season[1]) {
               $max_season = array($id, $item['last_season'], $item['last_episode']);
             }
          }
          
          $iframe_url = $response[$max_season[0]]['link'];    

          if ($max_season[1] > $output_season OR ($max_season[1] >= $output_season AND $max_season[2] > $output_episode)) {
            
            $more_recent = true;
            
            $iframe_url = $response[$max_season[0]]['link'];
              
            $iframe_voice = $response[$max_season[0]]['translation']['title'];
            $iframe_quality = $response[$max_season[0]]['quality'];
              
            $iframe_lastseason = $response[$max_season[0]]['last_season'];
            $iframe_lastepisode = $response[$max_season[0]]['last_episode'];            
            
            foreach ($response as $key=>$item) {
               if ( $item['last_season'] < $max_season[1] OR ($max_season[1] == $item['last_season'] AND $item['last_episode'] < $max_season[2]) ) {
                  unset($response[$key]);               
               }
            }
         }
         
        }
				//			

				switch ($kodik->config["{$voice_type}_quality"]) {
				
					case 1:
						foreach ($response as $item) {
							if (!$item['camrip']) {
								$iframe_url = $item['link'];
								$iframe_quality = $item['quality'];
								$iframe_voice = $item['translation']['title'];
                $iframe_lastseason = isset($item['last_season']) ? $item['last_season'] : 0;
                $iframe_lastepisode = isset($item['last_episode']) ? $item['last_episode'] : 0;
								break;
							}
						}
						break;

					case 2:
						$_result = $kodik->dle_db->query("SELECT * FROM " . PREFIX . "_kodik_voice WHERE {$voice_type}_priority > 0 ORDER BY {$voice_type}_priority ASC");
						while ($row = $_result->fetch_assoc()) {
							foreach ($response as $item) {
								if ($item['translator_id'] == $row['voice_id']) {
									$iframe_url = $item['link'];
									$iframe_quality = $item['quality'];
									$iframe_voice = $item['translation']['title'];
                  $iframe_lastseason = isset($item['last_season']) ? $item['last_season'] : 0;
                  $iframe_lastepisode = isset($item['last_episode']) ? $item['last_episode'] : 0;									
									break 2;
								}
							}
						}
						break;

					case 3:
						$_result = $kodik->dle_db->query("SELECT * FROM " . PREFIX . "_kodik_voice WHERE {$voice_type}_priority > 0 ORDER BY {$voice_type}_priority ASC");
						while ($row = $_result->fetch_assoc()) {
							foreach ($response as $item) {
								if ($item['translator_id'] == $row['voice_id']) {
									$iframe_url = $item['link'];
									$iframe_quality = $item['quality'];
									$iframe_voice = $item['translation']['title'];
                  $iframe_lastseason = isset($item['last_season']) ? $item['last_season'] : 0;
                  $iframe_lastepisode = isset($item['last_episode']) ? $item['last_episode'] : 0;									

									if ($item['camrip']) {
										foreach ($response as $_item) {
											if ($_item['translator_id'] == $row['voice_id'] && !$_item['camrip']) {
												$iframe_url = $_item['link'];
												$iframe_quality = $_item['quality'];
												$iframe_voice = $_item['translation']['title'];
                        $iframe_lastseason = isset($_item['last_season']) ? $_item['last_season'] : 0;
                        $iframe_lastepisode = isset($_item['last_episode']) ? $_item['last_episode'] : 0;
												break;
											}
										}
									}

									break 2;
								}
							}
						}
						break;

					case 4:
						foreach ($response as $item) {
							if (!$item['camrip']) {
								$iframe_url = $item['link'];
								$iframe_quality = $item['quality'];
								$iframe_voice = $item['translation']['title'];
                $iframe_lastseason = isset($item['last_season']) ? $item['last_season'] : 0;
                $iframe_lastepisode = isset($item['last_episode']) ? $item['last_episode'] : 0;										

								$_result = $kodik->dle_db->query("SELECT * FROM " . PREFIX . "_kodik_voice WHERE {$voice_type}_priority > 0 ORDER BY {$voice_type}_priority ASC");
								while ($row = $_result->fetch_assoc()) {
									foreach ($response as $_item) {
										if (!$_item['camrip'] && $_item['translator_id'] == $row['voice_id']) {
											$iframe_url = $_item['link'];
											$iframe_quality = $_item['quality'];
											$iframe_voice = $_item['translation']['title'];
                      $iframe_lastseason = isset($_item['last_season']) ? $_item['last_season'] : 0;
                      $iframe_lastepisode = isset($_item['last_episode']) ? $_item['last_episode'] : 0;														
											break 2;
										}
									}
								}

								break;
							}
						}
						break;				
						
				}			
								
				if ( ($iframe_url != '' AND $iframe_url != $output) OR ($iframe_quality != '' AND $iframe_quality != $output_quality) AND $more_recent) {
					
					
					$field_set = array();
					
					// this field is used
            if ($kodik->config['output']) {
              if ($kodik->config['player_params']) $iframe_url .= $kodik->config['player_params'];
              
              $_field = explode('|', $kodik->config['output']);
              if(count($_field) == 1) $field_set[] = "{$_field[0]}='".$kodik->dle_db->safesql($iframe_url)."'";
              elseif(count($_field) == 3) $xfieldsdata[$_field_output[0]] = $iframe_url;
            }
              						
						// add new fields data
						
						if ($kodik->config['output_voice']) {
              $_field = explode('|', $kodik->config['output_voice']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_voice, $config['charset']);
						}
						
						if ($kodik->config['output_quality']) {
              $_field = explode('|', $kodik->config['output_quality']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_quality, $config['charset']);
						}
						
						if ($kodik->config['kinopoisk_id'] AND $kodik->config['allow_autopaste'] AND $iframe_kinopoisk_id != '') {
              $_field = explode('|', $kodik->config['kinopoisk_id']);
              $xfieldsdata[$_field[0]] = $iframe_kinopoisk_id;
						}
						
						if ($kodik->config['imdb_id'] AND $kodik->config['allow_autopaste'] AND $iframe_imdb_id != '') {
              $_field = explode('|', $kodik->config['imdb_id']);
              $xfieldsdata[$_field[0]] = $iframe_imdb_id;
						}	
						
						if ($kodik->config['pornolab_id'] AND $kodik->config['allow_autopaste'] AND $iframe_pornolab_id != '') {
              $_field = explode('|', $kodik->config['pornolab_id']);
              $xfieldsdata[$_field[0]] = $iframe_pornolab_id;
						}	
						
            // http://www.world-art.ru/animation/animation.php?id=9979
            // http://www.world-art.ru/cinema/cinema.php?id=81841
		
						if ($kodik->config['world_art_id'] AND $kodik->config['allow_autopaste'] AND $iframe_worldartlink != '') {
              $_field = explode('|', $kodik->config['world_art_id']);
              if (preg_match('#cinema\.php\?id=(\d+)#', $iframe_worldartlink, $matches)) {              
                $xfieldsdata[$_field[0]] = $matches[1];
              }
						}
						
						if ($kodik->config['world_artanimation_id'] AND $kodik->config['allow_autopaste'] AND $iframe_worldartlink != '') {
              $_field = explode('|', $kodik->config['world_artanimation_id']);
              if (preg_match('#animation\.php\?id=(\d+)#', $iframe_worldartlink, $matches)) {              
                $xfieldsdata[$_field[0]] = $matches[1];
              }              
						}																		
						
            //
            //						
						if ($kodik->config['output_title'] AND $iframe_title != '') {
              $_field = explode('|', $kodik->config['output_title']);              
              if(count($_field) == 1) $field_set[] = "{$_field[0]}='".$kodik->dle_db->safesql(convert_unicode($iframe_title, $config['charset']))."'";
              elseif(count($_field) == 3) $xfieldsdata[$_field[0]] = convert_unicode($iframe_title, $config['charset']);
						}
						
						if ($kodik->config['output_otitle'] AND $iframe_origtitle != '') {
              $_field = explode('|', $kodik->config['output_otitle']);
              if(count($_field) == 1) $field_set[] = "{$_field[0]}='".$kodik->dle_db->safesql(convert_unicode($iframe_origtitle, $config['charset']))."'";
              elseif(count($_field) == 3) $xfieldsdata[$_field[0]] = convert_unicode($iframe_origtitle, $config['charset']);  
						}	
						
						if ($kodik->config['world_art_link'] AND $iframe_worldartlink != '') {
              $_field = explode('|', $kodik->config['world_art_link']);
              $xfieldsdata[$_field[0]] = $iframe_worldartlink;
						}	
						
						if ($kodik->config['output_year'] AND $iframe_year != '') {
              $_field = explode('|', $kodik->config['output_year']);
              $xfieldsdata[$_field[0]] = $iframe_year;
						}										
						
						if ($kodik->config['output_season'] && $iframe_lastseason > 0) {
              $_field = explode('|', $kodik->config['output_season']);
              $xfieldsdata[$_field[0]] = $iframe_lastseason;
						}
						
						if ($kodik->config['output_episode'] && $iframe_lastepisode > 0) {
              $_field = explode('|', $kodik->config['output_episode']);
              $xfieldsdata[$_field[0]] = $iframe_lastepisode;												
						}
								
						//
						//				
						//
						
						if ($kodik->config['output_voiceall'] AND !empty($iframe_voiceall)) {
              $iframe_voiceall = array_unique($iframe_voiceall);
              $iframe_voiceall = implode(", ", $iframe_voiceall);
              $_field = explode('|', $kodik->config['output_voiceall']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_voiceall, $config['charset']);
						}
						
						//
						if ($kodik->config['output_kp_description'] AND $iframe_kp_description != '') {
              $_field = explode('|', $kodik->config['output_kp_description']);
              if(count($_field) == 1) $field_set[] = "{$_field[0]}='".$kodik->dle_db->safesql(convert_unicode($iframe_kp_description, $config['charset']))."'";
              elseif(count($_field) == 3) $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_description, $config['charset']);
						}			
						
						
						if ($kodik->config['output_kp_poster_url'] AND $iframe_kp_poster_url != '') {
              $_field = explode('|', $kodik->config['output_kp_poster_url']);
              $xfieldsdata[$_field[0]] = $iframe_kp_poster_url;
						}				
						
						
						if ($kodik->config['output_kp_duration'] AND $iframe_kp_duration != '') {
              $_field = explode('|', $kodik->config['output_kp_duration']);
              $xfieldsdata[$_field[0]] = $iframe_kp_duration;
						}												
						
						
						if ($kodik->config['output_kp_countries'] AND !empty($iframe_kp_countries)) {
              $iframe_kp_countries = implode(", ", $iframe_kp_countries);
              $_field = explode('|', $kodik->config['output_kp_countries']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_countries, $config['charset']);
						}	
						
						
						if ($kodik->config['output_kp_genres'] AND !empty($iframe_kp_genres)) {
              $iframe_kp_genres = implode(", ", $iframe_kp_genres);
              $_field = explode('|', $kodik->config['output_kp_genres']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_genres, $config['charset']);
						}		
						
						
						if ($kodik->config['output_kp_actors'] AND !empty($iframe_kp_actors)) {
              $iframe_kp_actors = implode(", ", $iframe_kp_actors);
              $_field = explode('|', $kodik->config['output_kp_actors']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_actors, $config['charset']);
						}	
						
						
						if ($kodik->config['output_kp_directors'] AND !empty($iframe_kp_directors)) {
              $iframe_kp_directors = implode(", ", $iframe_kp_directors);
              $_field = explode('|', $kodik->config['output_kp_directors']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_directors, $config['charset']);
						}	
											
            
						if ($kodik->config['output_kp_producers'] AND !empty($iframe_kp_producers)) {
              $iframe_kp_producers = implode(", ", $iframe_kp_producers);
              $_field = explode('|', $kodik->config['output_kp_producers']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_producers, $config['charset']);
						}	
						
            
						if ($kodik->config['output_kp_writers'] AND !empty($iframe_kp_writers)) {
              $iframe_kp_writers = implode(", ", $iframe_kp_writers);
              $_field = explode('|', $kodik->config['output_kp_writers']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_writers, $config['charset']);
						}	
						
						
						if ($kodik->config['output_kp_tagline'] AND $iframe_kp_tagline != '') {
              $_field = explode('|', $kodik->config['output_kp_tagline']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_tagline, $config['charset']);
						}	
						
						if ($kodik->config['output_kp_kinopoisk_rating'] AND $iframe_kp_kinopoisk_rating != '') {
              $_field = explode('|', $kodik->config['output_kp_kinopoisk_rating']);
              $xfieldsdata[$_field[0]] = $iframe_kp_kinopoisk_rating;
						}	
						
						
						if ($kodik->config['output_kp_kinopoisk_votes'] AND $iframe_kp_kinopoisk_votes != '') {
              $_field = explode('|', $kodik->config['output_kp_kinopoisk_votes']);
              $xfieldsdata[$_field[0]] = $iframe_kp_kinopoisk_votes;
						}	
						
						if ($kodik->config['output_kp_imdb_rating'] AND $iframe_kp_imdb_rating != '') {
              $_field = explode('|', $kodik->config['output_kp_imdb_rating']);
              $xfieldsdata[$_field[0]] = $iframe_kp_imdb_rating;
						}	
						
						
						if ($kodik->config['output_kp_imdb_votes'] AND $iframe_kp_imdb_votes != '') {
              $_field = explode('|', $kodik->config['output_kp_imdb_votes']);
              $xfieldsdata[$_field[0]] = $iframe_kp_imdb_votes;
						}	
						
						if ($kodik->config['output_kp_premiere_ru'] AND $iframe_kp_premiere_ru != '') {
              $_field = explode('|', $kodik->config['output_kp_premiere_ru']);
              $xfieldsdata[$_field[0]] = $iframe_kp_premiere_ru;
						}	
						
						
						if ($kodik->config['output_kp_premiere_world'] AND $iframe_kp_premiere_world != '') {
              $_field = explode('|', $kodik->config['output_kp_premiere_world']);
              $xfieldsdata[$_field[0]] = $iframe_kp_premiere_world;
						}	
						
						
						if ($kodik->config['output_kp_composers'] AND !empty($iframe_kp_composers)) {
              $iframe_kp_composers = implode(", ", $iframe_kp_composers);	
              $_field = explode('|', $kodik->config['output_kp_composers']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_composers, $config['charset']);
						}	
						
						
						if ($kodik->config['output_kp_editors'] AND !empty($iframe_kp_editors)) {
              $iframe_kp_editors = implode(", ", $iframe_kp_editors);
              $_field = explode('|', $kodik->config['output_kp_editors']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_editors, $config['charset']);
						}	
						
						
						if ($kodik->config['output_kp_designers'] AND !empty($iframe_kp_designers)) {
              $iframe_kp_designers = implode(", ", $iframe_kp_designers);
              $_field = explode('|', $kodik->config['output_kp_designers']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_designers, $config['charset']);
						}																	
						
						if ($kodik->config['output_kp_operators'] AND !empty($iframe_kp_operators)) {
              $iframe_kp_operators = implode(", ", $iframe_kp_operators);
              $_field = explode('|', $kodik->config['output_kp_operators']);
              $xfieldsdata[$_field[0]] = convert_unicode($iframe_kp_operators, $config['charset']);
						}			
						//
						//																																																															
						//
						
						$xfields = array();
						foreach ($xfieldsdata as $key => $value) {
							$value = str_replace('|', '&#124;', $value);
							$xfields[] = "$key|$value";
						}
						$xfields = implode('||', $xfields);

						$xfields = addslashes($xfields);
						
						$up_date = "";
						if ($kodik->config['up_news']) {
              $thistime = date( "Y-m-d H:i:s", time() );
              $up_date = ", date='{$thistime}'";
						}
						
						if(count($field_set)) {
              $set_nativefields = ", ". implode(", ", $field_set);
						}
						
					// end>?
					$kodik->dle_db->query("UPDATE " . PREFIX . "_post SET xfields = '{$xfields}'{$up_date}{$set_nativefields} WHERE id='{$post['id']}'");
					

					$result['post'] = $post;
					$result['kinopoisk_id'] = $kinopoisk_id;
					$result['out_base_id'] = $out_base_id;
					$result['out_base_name'] = $out_base_name;

					$added = date('d.m.Y H:i:s', time());

					if ($config['allow_alt_url']) {
						if ($config['seo_type'] == 1 || $config['seo_type'] == 2) {
							$result['post']['category'] = intval($result['post']['category']);
							if ($result['post']['category'] && $config['seo_type'] == 2) {
								$full_link = $config['http_home_url'] . get_url($result['post']['category']) . "/" . $result['post']['id'] . "-" . $result['post']['alt_name'] . ".html";
							} else {
								$full_link = $config['http_home_url'] . $result['post']['id'] . "-" . $result['post']['alt_name'] . ".html";
							}
						} else {
							$full_link = $config['http_home_url'] . date('Y/m/d/', $result['post']['date']) . $result['post']['alt_name'] . ".html";
						}
					} else {
						$full_link = $config['http_home_url'] . "index.php?newsid=" . $result['post']['id'];
					}

					$log_string = " $added [YES] $full_link" . ($result['out_base_id'] ? " ({$result['out_base_name']}: {$result['out_base_id']}) { {$iframe_url} }" : '') . "\r\n";
					file_put_contents(ENGINE_DIR . '/inc/kodik/reports/cron.log', $log_string, FILE_APPEND | LOCK_EX);
					
					if ($kodik->config['up_news']) {
					clear_cache( array('news_', 'full_'.$post['id']) );
					}
					
				} else {
					$result['post'] = $post;
					$result['kinopoisk_id'] = $kinopoisk_id;
					$result['out_base_id'] = $out_base_id;
					$result['out_base_name'] = $out_base_name;

					$added = date('d.m.Y H:i:s', time());

					if ($config['allow_alt_url']) {
						if ($config['seo_type'] == 1 || $config['seo_type'] == 2) {
							$result['post']['category'] = intval($result['post']['category']);
							if ($result['post']['category'] && $config['seo_type'] == 2) {
								$full_link = $config['http_home_url'] . get_url($result['post']['category']) . "/" . $result['post']['id'] . "-" . $result['post']['alt_name'] . ".html";
							} else {
								$full_link = $config['http_home_url'] . $result['post']['id'] . "-" . $result['post']['alt_name'] . ".html";
							}
						} else {
							$full_link = $config['http_home_url'] . date('Y/m/d/', $result['post']['date']) . $result['post']['alt_name'] . ".html";
						}
					} else {
						$full_link = $config['http_home_url'] . "index.php?newsid=" . $result['post']['id'];
					}

					$log_string = " $added [NO] $full_link" . ($result['out_base_id'] ? " ({$result['out_base_name']}: {$result['out_base_id']})" : '') . "\r\n";
					file_put_contents(ENGINE_DIR . '/inc/kodik/reports/cron.log', $log_string, FILE_APPEND | LOCK_EX);
				}
			}
		}

		// ----- END UPDATE POST -----

		if ($threads == $kodik->config['cron_threads'] AND $kodik->config['cron_mode'] == 0) {
			$threads = 0;

			if ($kodik->config['cron_interval'] > 0) {
				ob_flush();
				flush();

				sleep($kodik->config['cron_interval']);
			}
		}
		
		
	}
	
	if($kodik->config['cron_mode'] == 1) {
    $start_from = $start_from+$max_step;	
    sleep($kodik->config['cron_interval']);	
    goto row_init;	
	}
	
}